Index: src/main/java/net/sf/ehcache/distribution/jms/JMSCacheReplicator.java
===================================================================
--- src/main/java/net/sf/ehcache/distribution/jms/JMSCacheReplicator.java	(revision 1608)
+++ src/main/java/net/sf/ehcache/distribution/jms/JMSCacheReplicator.java	(working copy)
@@ -16,6 +16,12 @@
 
 package net.sf.ehcache.distribution.jms;
 
+import java.rmi.RemoteException;
+import java.util.ArrayList;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.logging.Level;
+
 import net.sf.ehcache.CacheException;
 import net.sf.ehcache.Ehcache;
 import net.sf.ehcache.Element;
@@ -25,12 +31,8 @@
 import net.sf.ehcache.distribution.CacheReplicator;
 import net.sf.ehcache.distribution.EventMessage;
 
-import java.rmi.RemoteException;
-import java.util.ArrayList;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.logging.Level;
-import java.util.logging.Logger;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
 
 /**
  * @author benoit.perroud@elca.ch
@@ -43,7 +45,7 @@
      */
     public static final long DEFAULT_ASYNC_INTERVAL = 1000;
 
-    private static final Logger LOG = Logger.getLogger(JMSCacheReplicator.class.getName());
+    private static final Logger LOG = LoggerFactory.getLogger(JMSCacheReplicator.class.getName());
 
     private long asynchronousReplicationInterval = DEFAULT_ASYNC_INTERVAL;
 
@@ -72,8 +74,8 @@
                               boolean replicateUpdatesViaCopy, boolean replicateRemovals,
                               boolean replicateAsync, long asynchronousReplicationInterval) {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("JMSCacheReplicator constructor ( replicatePuts = "
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("JMSCacheReplicator constructor ( replicatePuts = "
                     + replicatePuts + ", replicateUpdates = " + replicateUpdates + ", " +
                     "replicateUpdatesViaCopy = " + replicateUpdatesViaCopy + ", replicateRemovals = "
                     + replicateRemovals + ", replicateAsync = " + replicateAsync + " ) called");
@@ -102,8 +104,8 @@
      */
     public boolean alive() {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("alive ( ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("alive ( ) called ");
         }
 
         return status == Status.STATUS_ALIVE;
@@ -116,8 +118,8 @@
      */
     public boolean isReplicateUpdatesViaCopy() {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("isReplicateUpdatesViaCopy ( ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("isReplicateUpdatesViaCopy ( ) called ");
         }
 
         return replicateUpdatesViaCopy;
@@ -130,8 +132,8 @@
      */
     public boolean notAlive() {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notAlive ( ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notAlive ( ) called ");
         }
 
         return !alive();
@@ -149,8 +151,8 @@
      */
     public void dispose() {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("dispose ( ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("dispose ( ) called ");
         }
 
         status = Status.STATUS_SHUTDOWN;
@@ -231,16 +233,16 @@
             return;
         }
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notifyElementPut ( cache = " + cache + ", element = " + element + ") called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notifyElementPut ( cache = " + cache + ", element = " + element + ") called ");
         }
 
         if (!element.isKeySerializable()) {
-            LOG.warning("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
+            LOG.warn("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
             return;
         }
         if (!element.isSerializable()) {
-            LOG.warning("Object with key " + element.getObjectKey() + " is not Serializable and cannot be replicated");
+            LOG.warn("Object with key " + element.getObjectKey() + " is not Serializable and cannot be replicated");
             return;
         }
         replicatePut(cache, element);
@@ -273,16 +275,16 @@
             return;
         }
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notifyElementUpdated ( cache = " + cache + ", element = " + element + ") called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notifyElementUpdated ( cache = " + cache + ", element = " + element + ") called ");
         }
 
         if (!element.isKeySerializable()) {
-            LOG.warning("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
+            LOG.warn("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
             return;
         }
         if (!element.isSerializable()) {
-            LOG.warning("Object with key " + element.getObjectKey() + " is not Serializable and cannot be replicated");
+            LOG.warn("Object with key " + element.getObjectKey() + " is not Serializable and cannot be replicated");
             return;
         }
 
@@ -322,8 +324,8 @@
      */
     public void notifyElementRemoved(Ehcache cache, Element element) throws CacheException {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notifyElementRemoved ( cache = " + cache + ", element = " + element + ")");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notifyElementRemoved ( cache = " + cache + ", element = " + element + ")");
         }
 
         if (notAlive()) {
@@ -334,12 +336,12 @@
             return;
         }
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notifyElementRemoved ( cache = " + cache + ", element = " + element + ")");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notifyElementRemoved ( cache = " + cache + ", element = " + element + ")");
         }
 
         if (!element.isKeySerializable()) {
-            LOG.warning("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
+            LOG.warn("Key " + element.getObjectKey() + " is not Serializable and cannot be replicated.");
             return;
         }
         replicateRemoval(cache, element);
@@ -378,8 +380,8 @@
             return;
         }
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("notifyRemoveAll ( cache = " + cache + ") ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("notifyRemoveAll ( cache = " + cache + ") ");
         }
 
         JMSEventMessage message = new JMSEventMessage(Action.REMOVE_ALL, null, null, cache.getName(), null);
@@ -411,8 +413,8 @@
      */
     protected void sendNotification(Ehcache cache, JMSEventMessage message) {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("sendNotification ( " + message.toString() + " )");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("sendNotification ( " + message.toString() + " )");
         }
 
         if (replicateAsync) {
@@ -501,7 +503,7 @@
                 try {
                     Thread.sleep(getAsynchronousReplicationInterval());
                 } catch (InterruptedException e) {
-                    LOG.fine("Spool Thread interrupted.");
+                    LOG.info("Spool Thread interrupted.");
                     return;
                 }
             }
@@ -511,7 +513,7 @@
             try {
                 flushReplicationQueue();
             } catch (Throwable e) {
-                LOG.log(Level.WARNING, "Exception on flushing of replication queue: "
+                LOG.warn("Exception on flushing of replication queue: "
                         + e.getMessage() + ". Continuing...", e);
             }
         }
@@ -525,8 +527,8 @@
 
     private void flushReplicationQueue() {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("flushReplicationQueue ( ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("flushReplicationQueue ( ) called ");
         }
 
         List<AsyncJMSEventMessage> replicationQueueCopy;
@@ -551,7 +553,7 @@
                 try {
                     peer.send(messages);
                 } catch (RemoteException e) {
-                    LOG.warning("Unable to send message to remote peer. Message was: " + e.getMessage() + " continuing to send" +
+                    LOG.warn("Unable to send message to remote peer. Message was: " + e.getMessage() + " continuing to send" +
                             "remaining messages.");
                 }
             }
Index: src/main/java/net/sf/ehcache/distribution/jms/JMSCachePeer.java
===================================================================
--- src/main/java/net/sf/ehcache/distribution/jms/JMSCachePeer.java	(revision 1608)
+++ src/main/java/net/sf/ehcache/distribution/jms/JMSCachePeer.java	(working copy)
@@ -16,16 +16,18 @@
 
 package net.sf.ehcache.distribution.jms;
 
-import net.sf.ehcache.CacheManager;
-import net.sf.ehcache.Ehcache;
-import net.sf.ehcache.Element;
-import net.sf.ehcache.MimeTypeByteArray;
-import net.sf.ehcache.distribution.CachePeer;
 import static net.sf.ehcache.distribution.jms.JMSEventMessage.ACTION_PROPERTY;
 import static net.sf.ehcache.distribution.jms.JMSEventMessage.CACHE_NAME_PROPERTY;
 import static net.sf.ehcache.distribution.jms.JMSEventMessage.KEY_PROPERTY;
 import static net.sf.ehcache.distribution.jms.JMSUtil.CACHE_MANAGER_UID;
 
+import java.io.Serializable;
+import java.rmi.RemoteException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.logging.Level;
+
 import javax.jms.BytesMessage;
 import javax.jms.JMSException;
 import javax.jms.Message;
@@ -37,14 +39,16 @@
 import javax.jms.QueueSession;
 import javax.jms.Session;
 import javax.jms.TextMessage;
-import java.io.Serializable;
-import java.rmi.RemoteException;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.logging.Level;
-import java.util.logging.Logger;
 
+import net.sf.ehcache.CacheManager;
+import net.sf.ehcache.Ehcache;
+import net.sf.ehcache.Element;
+import net.sf.ehcache.MimeTypeByteArray;
+import net.sf.ehcache.distribution.CachePeer;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
 /**
  * A JMS Cache Peer subscribes to JMS messages, both from the replication topic and the get queue.
  *
@@ -53,7 +57,7 @@
  */
 public class JMSCachePeer implements CachePeer, MessageListener {
 
-    private static final Logger LOG = Logger.getLogger(JMSCachePeer.class.getName());
+    private static final Logger LOG = LoggerFactory.getLogger(JMSCachePeer.class.getName());
 
     /**
      * Used only in testing
@@ -82,8 +86,8 @@
                         QueueSession getQueueSession) {
 
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("JMSCachePeer constructor ( cacheManager = "
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("JMSCachePeer constructor ( cacheManager = "
                     + cacheManager
                     + ", messageProducer = " + messageProducer + " ) called");
         }
@@ -120,8 +124,8 @@
      */
     private void handleNotification(JMSEventMessage message, Ehcache cache) {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("handleNotification ( message = " + message + " ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("handleNotification ( message = " + message + " ) called ");
         }
 
         int event = message.getEvent();
@@ -137,9 +141,7 @@
                 removeAll(cache);
                 break;
             default:
-                if (LOG.isLoggable(Level.FINE)) {
-                    LOG.severe(" Undefined action " + event);
-                }
+                LOG.error(" Undefined action " + event);
         }
     }
 
@@ -155,8 +157,8 @@
      */
     private void handleNotification(Element element, Serializable key, Ehcache cache, Action action) {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("handleNotification ( element = " + element + " ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("handleNotification ( element = " + element + " ) called ");
         }
 
         if (action.equals(Action.PUT)) {
@@ -189,22 +191,22 @@
     }
 
     private void removeAll(Ehcache cache) {
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("removeAll ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("removeAll ");
         }
         cache.removeAll(true);
     }
 
     private void remove(Ehcache cache, Serializable key) {
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("remove ( key = " + key + " ) ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("remove ( key = " + key + " ) ");
         }
         cache.remove(key, true);
     }
 
     private void put(Ehcache cache, Element element) {
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("put ( element = " + element + " ) ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("put ( element = " + element + " ) ");
         }
         cache.put(element, true);
     }
@@ -218,8 +220,8 @@
      */
     public void send(List eventMessages) throws RemoteException {
 
-        if (LOG.isLoggable(Level.FINEST)) {
-            LOG.finest("send ( eventMessages = " + eventMessages + " ) called ");
+        if (LOG.isDebugEnabled()) {
+            LOG.debug("send ( eventMessages = " + eventMessages + " ) called ");
         }
 
         for (Object eventMessage : eventMessages) {
@@ -227,7 +229,7 @@
                 ObjectMessage message = producerSession.createObjectMessage((JMSEventMessage) eventMessage);
                 messageProducer.send(message);
             } catch (JMSException e) {
-                LOG.log(Level.SEVERE, e.getMessage(), e);
+                LOG.error( e.getMessage(), e);
                 throw new RemoteException(e.getMessage());
             }
         }
@@ -252,7 +254,7 @@
                         + "). Notification ignored.");
             }
         } catch (Exception e) {
-            LOG.log(Level.WARNING, "Unable to handle JMS Notification: " + e.getMessage(), e);
+            LOG.warn("Unable to handle JMS Notification: " + e.getMessage(), e);
         }
     }
 
@@ -263,8 +265,8 @@
 
         //If a non-cache publisher sends an Element
         if (object instanceof Element) {
-            if (LOG.isLoggable(Level.FINE)) {
-                LOG.fine(getName() + ": Element message received - " + object);
+            if (LOG.isDebugEnabled()) {
+                LOG.debug(getName() + ": Element message received - " + object);
             }
 
 
@@ -277,15 +279,15 @@
             handleNotification(element, key, cache, action);
 
         } else if (object instanceof JMSEventMessage) {
-            if (LOG.isLoggable(Level.FINE)) {
-                LOG.fine(getName() + ": JMSEventMessage message received - " + object);
+            if (LOG.isDebugEnabled()) {
+                LOG.debug(getName() + ": JMSEventMessage message received - " + object);
             }
 
 
             //no need for cacheName, mimeType, key or action properties as all are in message.
             JMSEventMessage jmsEventMessage = (JMSEventMessage) object;
-            if (LOG.isLoggable(Level.FINE)) {
-                LOG.fine(jmsEventMessage.toString());
+            if (LOG.isDebugEnabled()) {
+                LOG.debug(jmsEventMessage.toString());
             }
 
             Ehcache cache;
@@ -300,7 +302,7 @@
                     throw new InvalidJMSMessageException("No cache named " + cacheName + "exists in the target CacheManager.");
                 }
             } catch (Exception e) {
-                LOG.log(Level.SEVERE, e.getMessage(), e);
+                LOG.error( e.getMessage(), e);
                 return;
             }
             if (jmsEventMessage.getEvent() == Action.GET.toInt()) {
@@ -310,7 +312,7 @@
             }
 
         } else {
-            LOG.fine(getName() + ": Other ObjectMessage received - " + object);
+            LOG.info(getName() + ": Other ObjectMessage received - " + object);
 
 
             //no need for mimeType. An object has a type
@@ -323,8 +325,8 @@
 
     private void handleTextMessage(Message message) throws RemoteException, JMSException {
         TextMessage textMessage = (TextMessage) message;
-        if (LOG.isLoggable(Level.FINE)) {
-            LOG.fine(getName() + ": Other ObjectMessage received - " + textMessage);
+        if (LOG.isDebugEnabled()) {
+            LOG.debug(getName() + ": Other ObjectMessage received - " + textMessage);
         }
 
         Ehcache cache = extractAndValidateCache(message);
@@ -341,8 +343,8 @@
 
     private void handleBytesMessage(Message message) throws RemoteException, JMSException {
         BytesMessage bytesMessage = (BytesMessage) message;
-        if (LOG.isLoggable(Level.FINE)) {
-            LOG.fine(getName() + ": Other ObjectMessage received - " + bytesMessage);
+        if (LOG.isDebugEnabled()) {
+            LOG.debug(getName() + ": Other ObjectMessage received - " + bytesMessage);
         }
 
         Ehcache cache = extractAndValidateCache(message);
@@ -357,8 +359,8 @@
 
     private void handleGetRequest(ObjectMessage objectMessage, JMSEventMessage jmsEventMessage, Ehcache cache)
             throws JMSException {
-        if (LOG.isLoggable(Level.FINE)) {
-            LOG.fine(cacheManager.getName() + ": JMSEventMessage message received - " + objectMessage.getJMSMessageID());
+        if (LOG.isDebugEnabled()) {
+            LOG.debug(cacheManager.getName() + ": JMSEventMessage message received - " + objectMessage.getJMSMessageID());
         }
         Serializable keyOrKeys = jmsEventMessage.getSerializableKey();
         boolean collectionLoad = false;
@@ -372,7 +374,7 @@
             Serializable value = loadKeyOrKeys(cache, keyOrKeys, collectionLoad);
 
             int localCacheManagerUid = JMSUtil.localCacheManagerUid(cache);
-            LOG.log(Level.FINE, "Receiver CacheManager UID: {}", localCacheManagerUid);
+            LOG.info("Receiver CacheManager UID: {}", localCacheManagerUid);
 
             assert (objectMessage.getIntProperty(CACHE_MANAGER_UID) != localCacheManagerUid) :
                     "The JMSCachePeer received a getQueue request sent by a JMSCacheLoader belonging to the same" +
@@ -461,8 +463,8 @@
             } else if (message instanceof BytesMessage) {
                 mimeType = "application/octet-stream";
             }
-            if (LOG.isLoggable(Level.FINE)) {
-                LOG.fine("mimeType property not set. Auto setting MIME Type for message " + message.getJMSMessageID() + " to " + mimeType);
+            if (LOG.isDebugEnabled()) {
+                LOG.debug("mimeType property not set. Auto setting MIME Type for message " + message.getJMSMessageID() + " to " + mimeType);
             }
         }
         return mimeType;
Index: src/main/java/net/sf/ehcache/distribution/jms/Configuration.java
===================================================================
--- src/main/java/net/sf/ehcache/distribution/jms/Configuration.java	(revision 0)
+++ src/main/java/net/sf/ehcache/distribution/jms/Configuration.java	(revision 0)
@@ -0,0 +1,147 @@
+package net.sf.ehcache.distribution.jms;
+
+import static net.sf.ehcache.distribution.jms.JMSUtil.ACKNOWLEDGEMENT_MODE;
+import static net.sf.ehcache.distribution.jms.JMSUtil.DEFAULT_LOADER_ARGUMENT;
+import static net.sf.ehcache.distribution.jms.JMSUtil.GET_QUEUE_BINDING_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.GET_QUEUE_CONNECTION_FACTORY_BINDING_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.INITIAL_CONTEXT_FACTORY_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.PASSWORD;
+import static net.sf.ehcache.distribution.jms.JMSUtil.PROVIDER_URL;
+import static net.sf.ehcache.distribution.jms.JMSUtil.REPLICATION_TOPIC_BINDING_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.SECURITY_CREDENTIALS;
+import static net.sf.ehcache.distribution.jms.JMSUtil.SECURITY_PRINCIPAL_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.TOPIC_CONNECTION_FACTORY_BINDING_NAME;
+import static net.sf.ehcache.distribution.jms.JMSUtil.URL_PKG_PREFIXES;
+import static net.sf.ehcache.distribution.jms.JMSUtil.USERNAME;
+
+import java.util.Properties;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import javax.naming.Context;
+
+import net.sf.ehcache.util.PropertyUtil;
+
+public class Configuration {
+  private static final Logger LOG = LoggerFactory.getLogger(Configuration.class.getName());
+  private String securityPrincipalName;
+  private String securityCredentials;
+  private String initialContextFactoryName;
+  private String urlPkgPrefixes;
+  private String providerURL;
+  private String replicationTopicBindingName;
+  private String getQueueBindingName;
+  private String getQueueConnectionFactoryBindingName;
+  private String replicationTopicConnectionFactoryBindingName;
+  private String userName;
+  private String password;
+  private AcknowledgementMode effectiveAcknowledgementMode;
+  private String defaultLoaderArgument;
+
+  String getSecurityPrincipalName() {
+    return securityPrincipalName;
+  }
+
+  String getSecurityCredentials() {
+    return securityCredentials;
+  }
+
+  String getInitialContextFactoryName() {
+    return initialContextFactoryName;
+  }
+
+  String getUrlPkgPrefixes() {
+    return urlPkgPrefixes;
+  }
+
+  String getProviderURL() {
+    return providerURL;
+  }
+
+  String getReplicationTopicBindingName() {
+    return replicationTopicBindingName;
+  }
+
+  String getGetQueueBindingName() {
+    return getQueueBindingName;
+  }
+
+  String getGetQueueConnectionFactoryBindingName() {
+    return getQueueConnectionFactoryBindingName;
+  }
+
+  String getReplicationTopicConnectionFactoryBindingName() {
+    return replicationTopicConnectionFactoryBindingName;
+  }
+
+  String getUserName() {
+    return userName;
+  }
+
+  String getPassword() {
+    return password;
+  }
+
+  AcknowledgementMode getEffectiveAcknowledgementMode() {
+    return effectiveAcknowledgementMode;
+  }
+
+  public Configuration(Properties properties) {
+    securityPrincipalName = PropertyUtil.extractAndLogProperty(SECURITY_PRINCIPAL_NAME, properties);
+    securityCredentials = PropertyUtil.extractAndLogProperty(SECURITY_CREDENTIALS, properties);
+    initialContextFactoryName = PropertyUtil.extractAndLogProperty(INITIAL_CONTEXT_FACTORY_NAME, properties);
+    urlPkgPrefixes = PropertyUtil.extractAndLogProperty(URL_PKG_PREFIXES, properties);
+    providerURL = PropertyUtil.extractAndLogProperty(PROVIDER_URL, properties);
+    replicationTopicBindingName = PropertyUtil.extractAndLogProperty(REPLICATION_TOPIC_BINDING_NAME, properties);
+    getQueueBindingName = PropertyUtil.extractAndLogProperty(GET_QUEUE_BINDING_NAME, properties);
+    getQueueConnectionFactoryBindingName = PropertyUtil.extractAndLogProperty(GET_QUEUE_CONNECTION_FACTORY_BINDING_NAME, properties);
+    replicationTopicConnectionFactoryBindingName = PropertyUtil.extractAndLogProperty(TOPIC_CONNECTION_FACTORY_BINDING_NAME, properties);
+    userName = PropertyUtil.extractAndLogProperty(USERNAME, properties);
+    password = PropertyUtil.extractAndLogProperty(PASSWORD, properties);
+    defaultLoaderArgument = PropertyUtil.extractAndLogProperty(DEFAULT_LOADER_ARGUMENT, properties);
+    String acknowledgementMode = PropertyUtil.extractAndLogProperty(ACKNOWLEDGEMENT_MODE, properties);
+    effectiveAcknowledgementMode = AcknowledgementMode.forString(acknowledgementMode);
+    
+  }
+
+  String getDefaultLoaderArgument() {
+    return defaultLoaderArgument;
+  }
+
+  public Properties getEnvironment() {
+    Properties env = new Properties();
+    if (replicationTopicConnectionFactoryBindingName != null) {
+      env.put(TOPIC_CONNECTION_FACTORY_BINDING_NAME, replicationTopicConnectionFactoryBindingName);
+    }
+    if (replicationTopicBindingName != null) {
+      env.put(REPLICATION_TOPIC_BINDING_NAME, replicationTopicBindingName);
+    }
+
+    if (getQueueConnectionFactoryBindingName != null) {
+      env.put(GET_QUEUE_CONNECTION_FACTORY_BINDING_NAME, getQueueConnectionFactoryBindingName);
+    }
+    if (getQueueBindingName != null) {
+      env.put(GET_QUEUE_BINDING_NAME, getQueueBindingName);
+    }
+    if (providerURL != null && !"".equals(providerURL)) {
+      env.put(Context.PROVIDER_URL, providerURL);
+    }
+
+    if (initialContextFactoryName != null) {
+      env.put(Context.INITIAL_CONTEXT_FACTORY, initialContextFactoryName);
+      if (urlPkgPrefixes != null) {
+        env.put(Context.URL_PKG_PREFIXES, urlPkgPrefixes);
+      }
+    }
+
+    if (securityPrincipalName != null) {
+      env.put(Context.SECURITY_PRINCIPAL, securityPrincipalName);
+      if (securityCredentials != null) {
+        env.put(Context.SECURITY_CREDENTIALS, securityCredentials);
+      } else {
+        LOG.warn("You have set SecurityPrincipalName option but not the " + "SecurityCredentials. This is likely to cause problems.");
+      }
+    }
+    return env;
+  }
+}
